******************************************************************************
*
* ADPCM Datatype, based on the sourcecode found in OS3.1 Native Developer Kit
*
* Written by Christian Buchner
*
******************************************************************************
* RomTag.asm
*


VERSION		EQU	40
REVISION	EQU	1
LIBNAME		MACRO
		dc.b	'adpcm.datatype',0
		ENDM
VSTRING		MACRO
		dc.b	'adpcm.datatype 40.1 (26.4.95) by Christian Buchner',13,10,0
		ENDM

;---------------------------------------------------------------------------

	INCLUDE "exec/types.i"
	INCLUDE "exec/libraries.i"
	INCLUDE "exec/lists.i"
	INCLUDE "exec/alerts.i"
	INCLUDE "exec/initializers.i"
	INCLUDE "exec/resident.i"
	INCLUDE "libraries/dos.i"

	INCLUDE "classbase.i"

;---------------------------------------------------------------------------

	XREF	_LibInit
	XREF	_LibOpen
	XREF	_LibClose
	XREF	_LibExpunge
	XREF	_LibReserved

	XREF	_ObtainClassEngine

	XDEF	_LibName

;---------------------------------------------------------------------------

; First executable location, must return an error to the caller

	SECTION	Code

	moveq   #-1,d0
	rts

;---------------------------------------------------------------------------

_ROMTAG
	DC.W	RTC_MATCHWORD	; UWORD RT_MATCHWORD
	DC.L	_ROMTAG		; APTR  RT_MATCHTAG
	DC.L	_ENDCODE	; APTR  RT_ENDSKIP
	DC.B	RTF_AUTOINIT	; UBYTE RT_FLAGS
	DC.B	VERSION		; UBYTE RT_VERSION
	DC.B	NT_LIBRARY	; UBYTE RT_TYPE
	DC.B	0		; BYTE  RT_PRI
	DC.L	_LibName	; APTR  RT_NAME
	DC.L	_LibId		; APTR  RT_IDSTRING
	DC.L	_LibInitTable	; APTR  RT_INIT

_ENDCODE

_LibName
	LIBNAME
	DC.B '$VER: '
_LibId	VSTRING

	CNOP    0,4

_LibInitTable
	DC.L	ClassBase_SIZEOF
	DC.L	_LibFuncTable
	DC.L	_LibDataTable
	DC.L	_LibInit

V_DEF	MACRO
	DC.W	\1+(*-_LibFuncTable)
	ENDM

_LibFuncTable
	DC.W	-1
	V_DEF	_LibOpen
	V_DEF	_LibClose
	V_DEF	_LibExpunge
	V_DEF	_LibReserved

	V_DEF	_ObtainClassEngine

	DC.W   -1

_LibDataTable
	INITBYTE	LN_TYPE,NT_LIBRARY
	INITLONG	LN_NAME,_LibName
	INITBYTE	LIB_FLAGS,(LIBF_SUMUSED!LIBF_CHANGED)
	INITWORD	LIB_VERSION,VERSION
	INITWORD	LIB_REVISION,REVISION
	INITLONG	LIB_IDSTRING,_LibId
	DC.W		0

	CNOP    0,4

;---------------------------------------------------------------------------

	END
